<template>
	<div @keydown="checkShiftTab($event)">
		<div
			v-if="toggleModal"
			class="fixed m-auto z-50 inset-0 flex left-0 top-0 h-screen overflow-auto"
			:class="[modelClass, popupNormal]"
		>
			<div
				id="topView"
				role="dialog"
				class="relative px-8 pb-10 md:pb-8 pt-15 md:pt-12"
				:class="[
					{ 'bg-white': !$route.path.includes('/account/companyProfile') },
					modalStyle,
					taxStyles ? ['mx-0 mt-5 md:mt-0', taxStyles] : 'mt-0 w-full md:h-auto',
					modalHeight,
				]"
				aria-modal="true"
				:aria-label="headerTitle"
			>
				<button
					v-if="!$route.path.includes('/account/companyProfile')"
					ref="cancel_button"
					class="rounded-md focus:outline-none focus:ring-2 focus:ring-black absolute right-3 top-3 p-1"
					aria-label="close"
					tabindex="0"
					@click="
						$emit('close-modal');
						$store.commit('MODAL_STORE/TOGGLE_MODAL');
					"
					@keydown.shift.tab.prevent="checkShiftTab($event)"
				>
					<img src="~/assets/images/icon-close-medium.svg" alt="close" />
				</button>
				<div class="flex justify-between items-center" :class="modalStyle ? 'xs:mb-2 lg:mb-4' : 'mb-8 md:mb-6 lg:mb-4'">
					<slot name="modalHeader"></slot>
				</div>
				<div>
					<slot name="modalContent"></slot>
				</div>
			</div>
		</div>
		<div
			v-if="toggleModal"
			class="fixed inset-0 z-40 opacity-25 bg-black"
			@click="
				$emit('close-modal');
				$store.commit('MODAL_STORE/TOGGLE_MODAL');
			"
			@keyup.enter="
				$emit('close-modal');
				$store.commit('MODAL_STORE/TOGGLE_MODAL');
			"
		></div>
	</div>
</template>
<script>
export default {
	name: 'MKModalWizardWrapper',
	props: {
		headerTitle: {
			type: String,
			default: '',
		},
		toggleModal: {
			type: Boolean,
			default: false,
		},
		toggleWidth: {
			type: String,
			default: '',
		},
		modelClass: {
			type: String,
			default: 'md:max-w-lg items-center p-5',
		},
		modalStyle: {
			type: String,
			default: 'mx-4 md:mx-0 px-4',
		},
		taxStyles: {
			type: String,
			default: '',
		},
		modalHeight: {
			type: String,
			default: 'h-screen',
		},
		handelShiftTab: {
			type: Boolean,
			default: false,
		},
		modalHeading: {
			type: String,
			default: '',
		},
		focusClose: {
			type: Boolean,
			default: false,
		},
	},
	data() {
		return {
			height: 0, // window height
			divHeight: 0,
			popupNormal: '',
			// popup height
		};
	},
	watch: {
		toggleModal() {
			this.scrollTop();
		},
		height() {
			this.onHeightChange();
		},
		divHeight() {
			this.onHeightChange();
		},
		focusClose: {
			deep: true,
			handler() {
				this.focus_btn();
			},
		},
	},
	mounted() {
		this.$nextTick(() => {
			window.addEventListener('resize', this.onResize);
		});
		this.height = window.innerHeight;
		this.onHeightChange();
		this.$root.$utility.elementFocus(this, 'cancel_button');
	},
	methods: {
		checkShiftTab(e) {
			if (e.keyCode === 27) {
				this.$emit('close-modal');
				this.$store.commit('MODAL_STORE/TOGGLE_MODAL');
			}
			if (this.handelShiftTab) {
				if (e.keyCode === 9) {
					if (e.shiftKey) {
						this.$root.$utility.elementFocus(this, 'cancel_button');
					} else {
						e.preventDefault();
					}
				}
			}
		},
		scrollTop() {
			if (this.toggleModal) {
				this.$root.$utility.elementFocus(this, 'cancel_button');

				const $parent = this;
				setTimeout(function () {
					const resizeObserver = new ResizeObserver(() => {
						$parent.divHeight = document.getElementById('topView').clientHeight;
					});
					resizeObserver.observe(document.querySelector('#topView'));

					$parent.onHeightChange();
				}, 500);
			}
		},
		onResize(e) {
			this.height = window.innerHeight;
		},
		onHeightChange() {
			this.height = window.innerHeight;
			if (this.height < this.divHeight) {
				this.popupNormal = 'items-start justify-start md:mt-20 md:pb-20';
			} else {
				this.popupNormal = 'items-center justify-center';
				// this.scrollTop()
			}
		},
		focus_btn() {
			if (this.focusClose) {
				this.$root.$utility.elementFocus(this, 'cancel_button');
			}
		},
	},
};
</script>
